## mingw-w64-pdal-2.9.2-1.src.tar.zst

=== CMakeLists.txt ===
#
# top-level CMake configuration file for PDAL
#
# (based originally on the libLAS files copyright Mateusz Loskot)

cmake_minimum_required(VERSION 3.13)

project(PDAL VERSION 2.9.2 LANGUAGES CXX C)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

set(ROOT_DIR "${PROJECT_SOURCE_DIR}")
include(${ROOT_DIR}/cmake/common.cmake NO_POLICY_SCOPE)

#------------------------------------------------------------------------------
# internal cmake settings
#------------------------------------------------------------------------------

set(CMAKE_COLOR_MAKEFILE ON)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
include(FeatureSummary)

# Allow advanced users to generate Makefiles printing detailed commands
mark_as_advanced(CMAKE_VERBOSE_MAKEFILE)

#------------------------------------------------------------------------------
# PDAL general settings
#------------------------------------------------------------------------------

#
# Must be changed if there is an ABI change.  This builds the SONAME
# that's embedded in the library and any plugins.
include(${ROOT_DIR}/cmake/libraries.cmake NO_POLICY_SCOPE)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

#
# Name of C++ library
#
set(PDAL_LIB_NAME pdalcpp)

set(PDAL_KAZHDAN_LIB_NAME pdal_kazhdan)
set(PDAL_LEPCC_LIB_NAME pdal_lepcc)
set(PDAL_TEST_SUPPORT_OBJS pdal_test_support)

set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

set(PDAL_OUTPUT_LIB_DIR "${PROJECT_BINARY_DIR}/lib")
set(PDAL_OUTPUT_BIN_DIR "${PROJECT_BINARY_DIR}/bin")


if (NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
endif()

if (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PDAL_OUTPUT_BIN_DIR}")
endif()

# allow override of PDAL_PLUGIN_INSTALL_PATH path
if (NOT PDAL_PLUGIN_INSTALL_PATH)
    if (WIN32)
        set(PDAL_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_BINDIR}" CACHE PATH "PDAL Plugin install location")
    else()
        set(PDAL_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_LIBDIR}" CACHE PATH "PDAL Plugin install location")
    endif()
endif()

include(${PDAL_CMAKE_DIR}/rpath.cmake)

# wipe lib/ drectory on clean. It will have plugins that could be out of date
# in the next build
set_directory_properties(PROPERTY ADDITIONAL_MAKE_CLEAN_FILES
    "${PDAL_OUTPUT_LIB_DIR}/*")

if(WIN32)
  add_definitions("-DPDAL_DLL_EXPORT=1")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CMAKE_BUILD_TYPE} "${PDAL_OUTPUT_LIB_DIR}" )
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CMAKE_BUILD_TYPE} "${PDAL_OUTPUT_BIN_DIR}" )
  # ---[ Windows requires DLLs (shared libraries) to be installed in
  # ---[ the same directory as executables
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CMAKE_BUILD_TYPE} "${PDAL_OUTPUT_BIN_DIR}" )
endif(WIN32)


# Choose package components

include(${PDAL_CMAKE_DIR}/options.cmake)

#------------------------------------------------------------------------------
# General build settings
#------------------------------------------------------------------------------

set(PDAL_BUILD_TYPE ${CMAKE_BUILD_TYPE})

#------------------------------------------------------------------------------
#  Dependencies.
#------------------------------------------------------------------------------

include(${PDAL_CMAKE_DIR}/backtrace.cmake)
include(${PDAL_CMAKE_DIR}/proj.cmake)
include(${PDAL_CMAKE_DIR}/gdal.cmake)
include(${PDAL_CMAKE_DIR}/geotiff.cmake)  # Optional (not really)
include(${PDAL_CMAKE_DIR}/threads.cmake)
include(${PDAL_CMAKE_DIR}/zlib.cmake)
include(${PDAL_CMAKE_DIR}/lzma.cmake)
include(${PDAL_CMAKE_DIR}/zstd.cmake)
include(${PDAL_CMAKE_DIR}/test.cmake)
include(${PDAL_CMAKE_DIR}/ctest.cmake)
include(${PDAL_CMAKE_DIR}/libxml2.cmake)
include(${PDAL_CMAKE_DIR}/dimension.cmake)
include(${PDAL_CMAKE_DIR}/arbiter.cmake)
include(${PDAL_CMAKE_DIR}/h3.cmake)
include(${PDAL_CMAKE_DIR}/nlohmann.cmake)
include(${PDAL_CMAKE_DIR}/schema-validator.cmake)
include(${PDAL_CMAKE_DIR}/lazperf.cmake)
include(${PDAL_CMAKE_DIR}/gcs.cmake) # Optional
include(${PDAL_CMAKE_DIR}/utfcpp.cmake)

#------------------------------------------------------------------------------
# generate the pdal_features.hpp header
#------------------------------------------------------------------------------

# from http://stackoverflow.com/questions/1435953/how-can-i-pass-git-sha1-to-compiler-as-definition-using-cmake
include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)

# needs to come before configuration of pdal_features
if(APPLE)
    option(PDAL_BUNDLE "Create PDAL as Application Bundle on OSX" FALSE)
    if (PDAL_BUNDLE)
        set(PDAL_APP_BUNDLE 1)
    endif()
endif()

set(pdal_features_hpp_in "${CMAKE_CURRENT_SOURCE_DIR}/pdal_features.hpp.in")
set(pdal_features_hpp
    "${CMAKE_CURRENT_BINARY_DIR}/include/pdal/pdal_features.hpp")
configure_file(${pdal_features_hpp_in} ${pdal_features_hpp})

#------------------------------------------------------------------------------
# subdirectory controls
#------------------------------------------------------------------------------

# PDAL_TARGET_OBJECTS is used to collect the driver object libraries
set(PDAL_TARGET_OBJECTS "")

if (WITH_TESTS)
    enable_testing()
endif()

add_subdirectory(plugins)

if (BUILD_DOCS)
    add_subdirectory(doc)
endif()
if (WITH_TESTS)
    include (${PDAL_CMAKE_DIR}/gtest.cmake)
    add_subdirectory(test)
endif()
add_subdirectory(dimbuilder)
add_subdirectory(vendor/arbiter)
add_subdirectory(vendor/schema-validator)
add_subdirectory(vendor/kazhdan)
add_subdirectory(vendor/lazperf)
add_subdirectory(vendor/utfcpp)
add_subdirectory(vendor/lepcc)
add_subdirectory(vendor/h3)
add_subdirectory(tools)
add_subdirectory(apps)

file(GLOB BASE_SRCS
    ${PDAL_FILTERS_DIR}/*.cpp
    ${PDAL_IO_DIR}/*.cpp
    ${PDAL_KERNELS_DIR}/*.cpp
    ${PDAL_SRC_DIR}/*.cpp
    ${PDAL_SRC_DIR}/compression/*.cpp
    ${PDAL_SRC_DIR}/util/*.cpp)
file(GLOB_RECURSE PRIVATE_SRCS
    ${PDAL_FILTERS_DIR}/private/*.cpp
    ${PDAL_IO_DIR}/private/*.cpp
    ${PDAL_KERNELS_DIR}/private/*.cpp
    ${PDAL_SRC_DIR}/private/*.cpp
    ${BACKTRACE_SOURCE})
list(APPEND SRCS ${BASE_SRCS} ${PRIVATE_SRCS})

#
# Remove stuff we don't want to build.
#
if (NOT PDAL_HAVE_LIBXML2)
    file(GLOB XML_SRCS
        io/Ilvis2MetadataReader.cpp
        io/Ilvis2Metadata.cpp
        io/Ilvis2Reader.cpp
        ${PDAL_SRC_DIR}/DbWriter.cpp
        ${PDAL_SRC_DIR}/DbReader.cpp
        ${PDAL_SRC_DIR}/XMLSchema.cpp)
    list(REMOVE_ITEM SRCS ${XML_SRCS})
endif()
if (NOT PDAL_HAVE_ZSTD)
    file(GLOB ZSTD_SRCS
        ${PDAL_SRC_DIR}/compression/ZstdCompression.cpp)
    list(REMOVE_ITEM SRCS ${ZSTD_SRCS})
endif()
if (NOT PDAL_HAVE_ZLIB)
    file(GLOB ZLIB_SRCS
        ${PDAL_SRC_DIR}/compression/DeflateCompression.cpp)
    list(REMOVE_ITEM SRCS ${ZLIB_SRCS})
endif()
if (NOT PDAL_HAVE_LZMA)
    file(GLOB LZMA_SRCS
        ${PDAL_SRC_DIR}/compression/LzmaCompression.cpp)
    list(REMOVE_ITEM SRCS ${LZMA_SRCS})
endif()

PDAL_ADD_LIBRARY(${PDAL_LIB_NAME} ${SRCS})
if (WIN32)
    # fix for "error C4005: '_XKEYCHECK_H': macro redefinition"
    # C:\Program Files (x86)\Microsoft Visual Studio\2019\Community\VC\Tools\MSVC\14.29.30133\
    # include\xkeycheck.h(55): fatal error C1189: #error:  The C++ Standard Library forbids
    # macroizing the keyword "bool". Enable warning C4005 to find the forbidden define.
    target_compile_definitions(${PDAL_LIB_NAME} PRIVATE _XKEYCHECK_H=1)
endif()
add_library(PDAL::PDAL ALIAS ${PDAL_LIB_NAME})
#
# Interface include directories allow downstream project to get the directory
# without specification.
#



target_include_directories(${PDAL_LIB_NAME}
    SYSTEM BEFORE PRIVATE
        ${PDAL_VENDOR_EIGEN_DIR}
        ${PDAL_VENDOR_DIR}/kazhdan
        ${PDAL_VENDOR_DIR}/h3/include
)
target_include_directories(${PDAL_LIB_NAME}
    PRIVATE
        ${ROOT_DIR}
        ${PROJECT_BINARY_DIR}/include
        ${PDAL_VENDOR_DIR}
        ${NLOHMANN_INCLUDE_DIR}
        ${GEOTIFF_INCLUDE_DIR}
        ${UTFCPP_INCLUDE_DIR}
)

target_link_libraries(${PDAL_LIB_NAME}
    PRIVATE
        ${CMAKE_THREAD_LIBS_INIT}
        ${CMAKE_DL_LIBS}
        GDAL::GDAL
        PROJ::proj
        ${GEOTIFF_LIBRARY}
        ${PDAL_REEXPORT}
        ${PDAL_ARBITER_LIB_NAME}
        ${PDAL_H3_LIB_NAME}
        ${JSON_SCHEMA_LIB_NAME}
        ${PDAL_KAZHDAN_LIB_NAME}
        ${PDAL_LEPCC_LIB_NAME}
        ${PDAL_LAZPERF_LIB_NAME}
        ${UTFCPP_LIB_NAME}
        ${BACKTRACE_LIBRARIES}
       "$<$<AND:$<CXX_COMPILER_ID:GNU>,$<VERSION_LESS:$<CXX_COMPILER_VERSION>,9.0>>:-lstdc++fs>"
    PUBLIC
        ${WINSOCK_LIBRARY}
    INTERFACE
        ${PDAL_LIBDIR}
        ${WINSOCK_LIBRARY}
)

if (ZSTD_FOUND)
    target_link_libraries(${PDAL_LIB_NAME}
        PRIVATE
        zstd::libzstd)
endif()

if (ZLIB_FOUND)
    target_link_libraries(${PDAL_LIB_NAME}
        PRIVATE
        ZLIB::ZLIB)
endif()

if (LIBLZMA_FOUND)
    target_link_libraries(${PDAL_LIB_NAME}
        PRIVATE
        LibLZMA::LibLZMA)
endif()

if (LibXml2_FOUND)
    target_link_libraries(${PDAL_LIB_NAME}
        PRIVATE
        LibXml2::LibXml2)
endif()



#
# Allow downstream cmake projects to find PDAL header files without
# being explicit.
#
target_include_directories(${PDAL_LIB_NAME}
    INTERFACE
        $<INSTALL_INTERFACE:include>)

target_compile_definitions(${PDAL_LIB_NAME}
    PRIVATE
    H3_PREFIX=PDALH3)

if(WIN32)
    target_compile_definitions(${PDAL_LIB_NAME}
        PUBLIC
            PDAL_DLL_EXPORT=1
    )
endif(WIN32)

set_target_properties(${PDAL_LIB_NAME} PROPERTIES
    VERSION ${PDAL_BUILD_VERSION}
    SOVERSION ${PDAL_API_VERSION}
    CLEAN_DIRECT_OUTPUT 1)

# shut off -Wpedantic selectively
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" )
    set_source_files_properties(filters/PoissonFilter.cpp PROPERTIES COMPILE_FLAGS "-Wno-pedantic -Wno-array-parameter")
endif()

#
# Installation
#

#
# Only install compression headers if we're building with the particular
# compression type.
#
if (NOT PDAL_HAVE_ZSTD)
    set(ZSTD_EXCLUDES PATTERN pdal/compression/Zstd* EXCLUDE)
endif()
if (NOT PDAL_HAVE_ZLIB)
    set(ZLIB_EXCLUDES PATTERN pdal/compression/Deflate* EXCLUDE)
endif()
if (NOT PDAL_HAVE_LZMA)
    set(LZMA_EXCLUDES PATTERN pdal/compression/Lzma* EXCLUDE)
endif()

install(DIRECTORY ${PDAL_INCLUDE_DIR}/pdal/
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/pdal"
    FILES_MATCHING PATTERN "*.hpp"
    PERMISSIONS
        GROUP_EXECUTE WORLD_EXECUTE OWNER_EXECUTE
        GROUP_READ WORLD_READ OWNER_READ
        OWNER_WRITE
#    PATTERN "pdal/private" EXCLUDE
#    PATTERN "pdal/io/private" EXCLUDE
#    PATTERN "pdal/pdal/private" EXCLUDE
#    PATTERN "pdal/util/private" EXCLUDE
#    PATTERN "pdal/filters/private" EXCLUDE
#    ${ZSTD_EXCLUDES}
#    ${ZLIB_EXCLUDES}
#    ${LZMA_EXCLUDES}
)

install(DIRECTORY ${PDAL_KERNELS_DIR}/
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/pdal/kernels"
    FILES_MATCHING PATTERN "*.hpp"
    PERMISSIONS
        GROUP_EXECUTE WORLD_EXECUTE OWNER_EXECUTE
        GROUP_READ WORLD_READ OWNER_READ
        OWNER_WRITE
#    PATTERN "private" EXCLUDE
)
install(DIRECTORY ${PDAL_IO_DIR}/
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/pdal/io"
    FILES_MATCHING PATTERN "*.hpp"
    PERMISSIONS
        GROUP_EXECUTE WORLD_EXECUTE OWNER_EXECUTE
        GROUP_READ WORLD_READ OWNER_READ
        OWNER_WRITE
#    PATTERN "private" EXCLUDE
)
install(DIRECTORY ${PDAL_FILTERS_DIR}/
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/pdal/filters"
    FILES_MATCHING PATTERN "*.hpp"
    PERMISSIONS
        GROUP_EXECUTE WORLD_EXECUTE OWNER_EXECUTE
        GROUP_READ WORLD_READ OWNER_READ
        OWNER_WRITE
#    PATTERN "private" EXCLUDE
)

install(FILES ${DIMENSION_OUTFILE} ${pdal_features_hpp}
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/pdal"
    PERMISSIONS
        GROUP_EXECUTE WORLD_EXECUTE OWNER_EXECUTE
        GROUP_READ WORLD_READ OWNER_READ
        OWNER_WRITE
)
install(FILES ${PDAL_CMAKE_DIR}/pluginmacros.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/PDAL

=== examples/writing/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(WritingTutorial)

find_package(PDAL 2.0.0 REQUIRED CONFIG)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_executable(tutorial tutorial.cpp)

target_link_libraries(tutorial PRIVATE ${PDAL_LIBRARIES})
target_include_directories(tutorial PRIVATE
    ${PDAL_INCLUDE_DIRS}
    ${PDAL_INCLUDE_DIRS}/pdal)

=== plugins/e57/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

if (STANDALONE)
    find_package(PDAL REQUIRED)
    include("${PROJECT_SOURCE_DIR}/../../cmake/standalone.cmake" )
    include("${PROJECT_SOURCE_DIR}/../../cmake/nlohmann.cmake" )
endif(STANDALONE)


add_subdirectory(libE57Format)

PDAL_ADD_PLUGIN(e57plugin_reader reader e57
    FILES
        io/E57Reader.cpp
        io/Scan.cpp
        io/Utils.cpp
    INCLUDES
        ${NLOHMANN_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}
    LINK_WITH
        E57Format
        ${PDAL_LIBRARIES}
    INCLUDES
        libE57Format/include
)
target_compile_definitions(${e57plugin_reader}
    PRIVATE
        ARBITER_ZLIB
        ARBITER_DLL_IMPORT
)

PDAL_ADD_PLUGIN(e57plugin_writer writer e57
    FILES
        io/E57Writer.cpp
        io/Utils.cpp
        io/Uuid.cpp
    LINK_WITH
        E57Format
        ${PDAL_LIBRARIES}
    INCLUDES
        libE57Format/include
)

if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_io_e57_read_test
        FILES
            test/E57ReaderTest.cpp
            test/E57UtilsTest.cpp
            test/ScanTest.cpp
        LINK_WITH
            ${e57plugin_reader}
            E57Format
        INCLUDES
            libE57Format/include
    )

    PDAL_ADD_TEST(pdal_io_e57_write_test
        FILES
            test/E57WriterTest.cpp
            test/E57UuidTest.cpp
        LINK_WITH
            ${e57plugin_reader}
            ${e57plugin_writer}
            E57Format
        INCLUDES
            libE57Format/include
    )
endif()

=== plugins/hdf/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

if (STANDALONE)
    project(pdal-hdf)
    include("${CMAKE_CURRENT_LIST_DIR}/../../cmake/standalone.cmake" )
    include(${PDAL_CMAKE_DIR}/arbiter.cmake)
    include(${PDAL_CMAKE_DIR}/nlohmann.cmake)
    include(${PDAL_CMAKE_DIR}/libxml2.cmake)
    add_subdirectory("${PROJECT_SOURCE_DIR}/../../vendor/arbiter" "vendor/arbiter")
    find_package(PDAL REQUIRED)
endif(STANDALONE)

#
# HDF plugin CMake configuration
#

include (${PDAL_CMAKE_DIR}/hdf5.cmake)


if (NOT PDAL_HAVE_HDF5)
    message(FATAL "HDF5 library is required to build HDF support.")
endif()

PDAL_ADD_PLUGIN(libname reader hdf
    FILES
        io/HdfReader.cpp
        io/Hdf5Handler.cpp
    LINK_WITH
        ${HDF5_LIBRARIES}
        ${PDAL_LIBRARIES}
    INCLUDES
        ${ROOT_DIR}
        ${NLOHMANN_INCLUDE_DIR}
)

if (WITH_TESTS AND NOT STANDALONE)
    PDAL_ADD_TEST(pdal_io_hdf_reader_test
        FILES test/HdfReadertest.cpp
        LINK_WITH ${libname}
        INCLUDES
            ${NLOHMANN_INCLUDE_DIR})
endif()

=== plugins/openscenegraph/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

if (STANDALONE)
    project(pdal-openscenegraph)
    include("${CMAKE_CURRENT_LIST_DIR}/../../cmake/standalone.cmake" )
    find_package(PDAL REQUIRED)
endif(STANDALONE)

#
# OpenScenGraph plugin CMake configuration
#

include (${PDAL_CMAKE_DIR}/openscenegraph.cmake)

# OpenSceneGraph Reader
#

PDAL_ADD_PLUGIN(reader_libname reader openscenegraph
    FILES
        io/OSGReader.cpp
        io/OSGReader.hpp
    LINK_WITH
        ${OPENTHREADS_LIBRARY}
        ${OSG_LIBRARY}
        ${OSGDB_LIBRARY}
        ${PDAL_LIBRARIES}
    INCLUDES
        ${OSG_INCLUDE_DIRS}
)

=== plugins/spz/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

if (STANDALONE)
    project(pdal-spz)
    find_package(PDAL REQUIRED)
    include("${PROJECT_SOURCE_DIR}/../../cmake/standalone.cmake" )
endif(STANDALONE)

include(${PDAL_CMAKE_DIR}/spz.cmake)
if (NOT PDAL_HAVE_SPZ)
    message("Can't find SPZ support required by SPZ plugin.")
else()
    set(SPZ_LIBRARIES spz::spz)
endif()

PDAL_ADD_PLUGIN(spz_reader reader spz
    FILES
        io/SpzReader.cpp
    LINK_WITH
        ${SPZ_LIBRARIES}
        ${PDAL_LIBRARIES}
    INCLUDES
        ${PDAL_VENDOR_DIR}
        ${NLOHMANN_INCLUDE_DIR}
        spz/src/cc
)

PDAL_ADD_PLUGIN(spz_writer writer spz
    FILES
        io/SpzWriter.cpp
    LINK_WITH
        ${SPZ_LIBRARIES}
        ${PDAL_LIBRARIES}
    INCLUDES
        ${PDAL_VENDOR_DIR}
        ${NLOHMANN_INCLUDE_DIR}
        spz/src/cc
)

if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_io_spz_reader_test
        FILES
            test/SpzReaderTest.cpp
        LINK_WITH
            ${PDAL_LIBRARIES}
            ${spz_reader}
        INCLUDES
            ${PROJECT_SOURCE_DIR}/plugins/spz/io
            spz/src/cc
    )

    PDAL_ADD_TEST(pdal_io_spz_writer_test
        FILES
            test/SpzWriterTest.cpp
        LINK_WITH
            ${PDAL_LIBRARIES}
            ${spz_writer}
            ${spz_reader}
        INCLUDES
            ${PROJECT_SOURCE_DIR}/plugins/spz/io
            spz/src/cc
        )
endif()

=== vendor/h3/CMakeLists.txt ===
#
# Make sure we don't attempt to add a library more than once
#

get_property(EXISTS GLOBAL PROPERTY _PDALH3_INCLUDED)
if (EXISTS)
    return()
endif()


set(H3SRCS
    "${CMAKE_CURRENT_SOURCE_DIR}/include/alloc.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/bbox.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/polygon.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/polygonAlgos.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/polyfill.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/h3Index.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/directedEdge.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/latLng.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/vec2d.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/vec3d.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/linkedGeo.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/localij.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/baseCells.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/faceijk.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/vertex.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/vertexGraph.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/mathExtensions.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/iterators.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/constants.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/coordijk.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/include/algos.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/algos.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/coordijk.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/bbox.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/polygon.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/polyfill.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/h3Index.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/vec2d.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/vec3d.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/vertex.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/linkedGeo.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/localij.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/latLng.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/directedEdge.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/mathExtensions.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/iterators.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/vertexGraph.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/faceijk.c"
    "${CMAKE_CURRENT_SOURCE_DIR}/lib/baseCells.c")


PDAL_ADD_FREE_LIBRARY(${PDAL_H3_LIB_NAME} STATIC ${H3SRCS})

target_compile_definitions(${PDAL_H3_LIB_NAME}
    PRIVATE
    H3_PREFIX=PDALH3)

target_include_directories(${PDAL_H3_LIB_NAME}
    BEFORE
    PRIVATE
        "${CMAKE_CURRENT_SOURCE_DIR}/include")

if (NOT MSVC)
    target_compile_options(${PDAL_H3_LIB_NAME} PRIVATE -Wno-cast-qual)
endif()


# H3 is built static but is included in a shared lib.
set_target_properties(${PDAL_H3_LIB_NAME} PROPERTIES POSITION_INDEPENDENT_CODE ON)


set_target_properties(${PDAL_H3_LIB_NAME} PROPERTIES
    VERSION "${PDAL_BUILD_VERSION}"
    SOVERSION "${PDAL_API_VERSION}"
    CLEAN_DIRECT_OUTPUT 1)

set_property(GLOBAL PROPERTY _PDALH3_INCLUDED TRUE)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=pdal
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.9.2
pkgrel=1
pkgdesc="A C++ library for translating and manipulating point cloud data (mingw-w64)"
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.pdal.io"
msys2_repository_url="https://github.com/PDAL/PDAL"
msys2_references=(
  'anitya: 138228'
  'archlinux: pdal'
  'gentoo: sci-libs/pdal'
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-curl"
         "${MINGW_PACKAGE_PREFIX}-gdal"
         "${MINGW_PACKAGE_PREFIX}-libgeotiff"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-openssl"
         "${MINGW_PACKAGE_PREFIX}-proj"
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zlib"
         "${MINGW_PACKAGE_PREFIX}-zstd")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-draco"
             "${MINGW_PACKAGE_PREFIX}-hdf5"
             "${MINGW_PACKAGE_PREFIX}-postgresql"
             "${MINGW_PACKAGE_PREFIX}-tiledb")
optdepends=("${MINGW_PACKAGE_PREFIX}-draco: Draco plugin, Read data in the draco format"
            "${MINGW_PACKAGE_PREFIX}-hdf5: HDF plugin, read data in the HDF format"
            "${MINGW_PACKAGE_PREFIX}-postgresql: PostgreSQL PointCloud plugin, read/write PostgreSQL PointCloud objects"
            "${MINGW_PACKAGE_PREFIX}-tiledb: TileDB plugin, read/write data from TileDB")
source=("https://github.com/PDAL/PDAL/releases/download/${pkgver}/PDAL-${pkgver}-src.tar.bz2")
sha256sums=('a74bbc7f4e4f709ed589dbbb851926a63c391c974e3fc40a4c3ff34f7923021b')

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  "${MINGW_PREFIX}"/bin/cmake.exe \
    -Wno-dev \
    -GNinja \
    "${_extra_config[@]}" \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DBUILD_SHARED_LIBS=ON \
    -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
    -DWITH_TESTS=OFF \
    -DBUILD_PLUGIN_DRACO=ON \
    -DBUILD_PLUGIN_HDF=ON \
    -DBUILD_PLUGIN_ICEBRIDGE=ON \
    -DBUILD_PLUGIN_PGPOINTCLOUD=ON \
    -DBUILD_PLUGIN_TILEDB=ON \
    -DWITH_BACKTRACE=OFF \
    -DWITH_LZMA=ON \
    ../PDAL-${pkgver}-src

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}"/build-${MSYSTEM}
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  install -Dm644 "${srcdir}"/PDAL-${pkgver}-src/LICENSE.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
